// Generated by CoffeeScript 2.4.1
(function() {
  var CouchDB, chai,
    hasProp = {}.hasOwnProperty;

  chai = require('chai');

  chai.should();

  CouchDB = require('most-couchdb');

  describe('client-ingress-post', function() {
    var Foo, cfg, docs, m, prov, ref, ref1, s, sc;
    m = require('../middleware/client/ingress/post');
    s = require('../middleware/setup');
    sc = require('../middleware/client/setup');
    Foo = class Foo {
      get_destination() {}

      add_in() {}

      set_endpoint() {}

      set_account() {}

      get_call_options() {}

      get_dev_logger() {}

      get_in() {
        return Promise.resolve([]);
      }

    };
    cfg = {
      Reference: Foo,
      prefix_admin: `http://${(ref = process.env.COUCHDB_USER) != null ? ref : 'admin'}:${(ref1 = process.env.COUCHDB_PASSWORD) != null ? ref1 : 'password'}@couchdb:5984`
    };
    docs = {
      'number:1234@some': {
        _id: 'number:1234@some',
        cfb_number: '365',
        cfa_number: '488',
        cfa_enabled: false,
        cfnr_number: '981',
        cfnr_enabled: false,
        cfda: 'sip:387@example.net'
      }
    };
    prov = new CouchDB(`${cfg.prefix_admin}/provisioning`);
    before(async function() {
      var doc, k, results;
      await prov.destroy().catch(function() {
        return true;
      });
      await prov.create();
      results = [];
      for (k in docs) {
        if (!hasProp.call(docs, k)) continue;
        doc = docs[k];
        results.push((await prov.put(doc)));
      }
      return results;
    });
    after(async function() {
      return (await prov.destroy());
    });
    return it('should use cfb_number', function(done) {
      var ctx;
      ctx = {
        cfg: cfg,
        destination: '1234',
        session: {
          direction: 'ingress',
          number_domain: 'some'
        },
        action: function() {
          return Promise.resolve(null);
        },
        res: {
          set: function() {
            return Promise.resolve(null);
          },
          export: function() {
            return Promise.resolve(null);
          }
        },
        req: {
          variable: function() {}
        },
        call: {
          uuid: 'little-bear',
          emit: function() {},
          on: function() {}
        },
        data: {
          'Channel-Context': 'sbc-ingress'
        }
      };
      s.include.call(ctx, ctx);
      sc.include.call(ctx, ctx);
      m.include.call(ctx).then(function() {
        ctx.session.should.have.property('cfb_number', '365');
        ctx.session.should.not.have.property('cfa_number');
        ctx.session.should.not.have.property('cfnr_number');
        ctx.session.should.have.property('cfda', 'sip:387@example.net');
        return done();
      }).catch(done);
      return null;
    });
  });

}).call(this);
